/**
* ...
* @author Dani Llops
* @version 0.1
*/

package com.llops
{
	import flash.display.*;
	import flash.events.*;
	import fl.controls.Slider;
	import flash.text.TextField;
	import com.llops.utils.PixelColorConverter;
	
	public class MainSelector extends MovieClip
	{
		// Clips en el escenario
		public var alpha_txt		:TextField;
		public var red_txt			:TextField;
		public var green_txt		:TextField;
		public var blue_txt			:TextField;
		public var alpha_dec_txt	:TextField;
		public var red_dec_txt		:TextField;
		public var green_dec_txt	:TextField;
		public var blue_dec_txt		:TextField;
		public var alpha_hex_txt	:TextField;
		public var red_hex_txt		:TextField;
		public var green_hex_txt	:TextField;
		public var blue_hex_txt		:TextField;
		public var decimal_txt		:TextField;
		public var hexadecimal_txt	:TextField;
		public var alpha_slider		:Slider;
		public var red_slider		:Slider;
		public var green_slider		:Slider;
		public var blue_slider		:Slider;
		
		// Bitmap
		private var _bmpData:BitmapData = new BitmapData(50,50,true,0);
		private var _bmp:Bitmap = new Bitmap(_bmpData);
		
		// Variables de color
		private var _azul:uint = 0xFF0000FF;
		private var _bitmapColor:PixelColorConverter = new PixelColorConverter(_azul);
		
		
		function MainSelector() {	
			init();
		}
		
		private function init():void 
		{
			// Update color
			updateBitmapDataColor();
			
			// Ajustamos el bitmap
			_bmp.x = 378;
			_bmp.y = 57;
			addChild(_bmp);
			
			// Eventos
			alpha_slider.addEventListener(Event.ADDED, evAdded);
			red_slider.addEventListener(Event.ADDED, evAdded);
			green_slider.addEventListener(Event.ADDED, evAdded);
			blue_slider.addEventListener(Event.ADDED, evAdded);
			
			alpha_slider.addEventListener(Event.CHANGE, cambioColor);
			red_slider.addEventListener(Event.CHANGE, cambioColor);
			green_slider.addEventListener(Event.CHANGE, cambioColor);
			blue_slider.addEventListener(Event.CHANGE, cambioColor);
		}
		
		private function evAdded(e:Event):void 
		{
			var sl:Slider = Slider(e.currentTarget);
			if (sl.name == "alpha_slider" || sl.name == "blue_slider") sl.value = 255
			else sl.value = 0;
			
			updateInfo(sl);
			sl.removeEventListener(Event.ADDED, evAdded);
		}
		
		private function cambioColor(e:Event):void 
		{
			var sl:Slider = Slider(e.target);			
			updateInfo(sl);
			updateBitmapDataColor();
		}
		
		private function updateInfo(sl:Slider):void 
		{
			switch(sl.name)
			{
				case "alpha_slider":
					_bitmapColor.setAlpha(sl.value);
					alpha_txt.text = _bitmapColor.getAlpha().toString();
					alpha_dec_txt.text = _bitmapColor.getAlpha().toString();
					var a:String = _bitmapColor.toStringAlpha();
					if (a.length == 1) a = "0"+a;
					alpha_hex_txt.text = a;
				break;
					
				case "red_slider":
					_bitmapColor.setRed(sl.value);
					red_txt.text = _bitmapColor.getRed().toString();
					red_dec_txt.text = _bitmapColor.getRed().toString();
					var r:String = _bitmapColor.toStringRed();
					if (r.length == 1) r = "0"+r;
					red_hex_txt.text = r;
				break;
				
				case "green_slider":
					_bitmapColor.setGreen(sl.value);
					green_txt.text = _bitmapColor.getGreen().toString();
					green_dec_txt.text = _bitmapColor.getGreen().toString();
					var g:String = _bitmapColor.toStringGreen();
					if (g.length == 1) g = "0"+g;
					green_hex_txt.text = g;
				break;
				
				case "blue_slider":
					_bitmapColor.setBlue(sl.value);
					blue_txt.text = _bitmapColor.getBlue().toString();
					blue_dec_txt.text = _bitmapColor.getBlue().toString();
					var b:String = _bitmapColor.toStringBlue();
					if (b.length == 1) b = "0"+b;
					blue_hex_txt.text = b;
				break;
			}
			
			decimal_txt.text 		= "=   " + _bitmapColor.getValue().toString();
			hexadecimal_txt.text	= "=   " + _bitmapColor.toStringHex();
		}
		
		private function updateBitmapDataColor():void 
		{
			_bmpData.fillRect(_bmpData.rect, _bitmapColor.getValue());
		}
	}
}